/*
 * item:
 * {"id":"263228491078566292","from":"13810332931","to":"15901489910",
 * "action":"audio",
 * "ext":{"audio":"http://ocnh9amrl.bkt.clouddn.com/2016_11_11_16_20_58_836_audio",
 * "type":"chat",
 * "head_img":"http://imgsrc.baidu.com/baike/pic/item/f7246b600c3387449002d272560fd9f9d62aa0fd.jpg",
 * "weichat":{"originType":"webim"}}}
 */
function message_cache(message)
{
	 //sql: "CREATE TABLE IF NOT EXISTS chat(Id INTEGER PRIMARY KEY AUTOINCREMENT, message_id varchar(24), from varchar(30),"+
		//"to varchar(30), action varchar(10), ext TEXT, status integer, type varchar(10))"
	//alert("message_cache");
	var db = api.require('db');
	db.openDatabase({
		  name:"chat",
		  path:"fs://data/chat.db"
	  }, function(ret, err) {
	  	var message_id = message.id;
		var from = message.from;
		var to = message.to;
		var action = message.action;
		var ext = JSON.stringify(message.ext);
		var type = message.ext.type;
		var insert_sql = "insert into chat_data('message_id','fromer','toer','action','ext','status','type')values('"+message_id+"','"+from+"','"
			    	+to+"','"+action+"','"+ext+"',0,'"+type+"')";
	    db.executeSql({
			    name: 'chat',
			    sql: insert_sql
			}, function(ret, err) {
				//alert(JSON.stringify(ret)+";"+JSON.stringify(err));
			}
		);
	  }
	);
}	

function historyMessage()
{
	var db = api.require('db');
	db.openDatabase({
		  name:"chat",
		  path:"fs://data/chat.db"
	  }, function(ret, err) {
		if(ret.status)
		{
			var select_sql = "SELECT * FROM chat_data where fromer='"+toUserName+"' and status=0"; 
			db.selectSql({
			    name: 'chat',
			    sql: select_sql
			}, function(ret, err) {
			    if (ret.status) {
			    	var data = ret.data;
			    	for(var i=0; i<data.length; i++)
			    	{
			    		var message = {
			    			"id":data[i].message_id,
			    			"from":data[i].fromer,
			    			"to":data[i].toer,
			    			"action":data[i].action,
			    			"ext":JSON.parse(data[i].ext)
			    		}
			    		cmdMessage(message);
			    	}
			    	update_data();
			    }
			});			
		}
	});
}

/**
 * 更新数据库未读消息
 */
function update_data()
{
	var db = api.require('db');
	db.openDatabase({
		  name:"chat",
		  path:"fs://data/chat.db"
	  }, function(ret, err) {
		if(ret.status)
		{
			var update_sql = "UPDATE chat_data SET status=1 WHERE fromer=\""+toUserName+"\"";
	    	db.executeSql({
				    name: 'chat',
				    sql: update_sql
				}, function(ret, err){
					//alert(JSON.stringify(ret)+";"+JSON.stringify(err));
				}
			);
		}
	});
}

/**
 * @toUserName string 收消息的人
 * @message string 消息内容
 * @action string 消息的类别｛text，iamge，audio，video｝
 * @type string 消息来源的类别｛chat，chatroom，chatgroup｝
 * @isGroup bool 是否群发
 */
function sendMessage(toUserName,message,action,type,isGroup)
{
	var id = conn.getUniqueId();//生成本地消息id
	var msg = new WebIM.message('cmd', id);//创建命令消息
	var username = $api.getStorage("username");
	var userId = $api.getStorage("user_id");
	if(action == "text")
	{
		msg.set({
		  msg: message,//消息内容
		  to: toUserName,//收消息人的环信用户名
		  action: action, //消息类别
		  ext:{"text":message,"type":type,"head_img":$api.getStorage("user_img"),"username":username,"userId":userId},
		  success: function ( id,serverMsgId ) {
		  	//alert("success");
		  }   
		});  
	}
	if(action == "image")
	{
		msg.set({
		  msg: message,//消息内容
		  to: toUserName,//收消息人的环信用户名
		  action: action, //消息类别
		  ext:{"image":message,"type":type,"head_img":$api.getStorage("user_img"),"username":username,"userId":userId},
		  success: function ( id,serverMsgId ) {}   
		});
	}
	if(action == "audio")
	{
		msg.set({
		  msg: message,//消息内容
		  to: toUserName,//收消息人的环信用户名
		  action: action, //消息类别
		  ext:{"audio":message,"type":type,"head_img":$api.getStorage("user_img"),"username":username,"userId":userId},
		  success: function ( id,serverMsgId ) {}   
		});
	}
	if(action == "video")
	{
		msg.set({
		  msg: message,//消息内容
		  to: toUserName,//收消息人的环信用户名
		  action: action, //消息类别
		  ext:{"video":message,"type":type,"head_img":$api.getStorage("user_img"),"username":username,"userId":userId},
		  success: function ( id,serverMsgId ) {}   
		});
	}
	if(isGroup && type=="chatroom")
	{
		msg.body.roomType = true;
		msg.setGroup("groupchat");
	}
	if(isGroup && type=="chatgroup")
	{
		msg.setGroup("groupchat");
	}
	conn.send(msg.body);
}


/**
 *获取当前时间字符串 
**/
function getTimeString()
{
	var date = new Date();
	Y = date.getFullYear() + '-';
	M = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1) + '-';
	D = date.getDate() + ' ';
	h = date.getHours() + ':';
	m = date.getMinutes() + ':';
	s = date.getSeconds();
	return Y+M+D+h+m+s;
}
/**
 * 构造七牛唯一文件名
 * @param string type//文件的类型
 */
function createFileName(type)
{
	var date = new Date();
	Y = date.getFullYear();
	M = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1);
	D = date.getDate();
	h = date.getHours();
	m = date.getMinutes();
	s = date.getSeconds();
	ms = date.getMilliseconds();
	return $api.getStorage("user_id")+"_"+Y+"_"+M+"_"+D+"_"+h+"_"+m+"_"+s+"_"+ms+"_"+type;
}









