function aiba_alert(title,content)
{
	var title = title || '爱吧提示';
	api.alert({
	    title: title,
	    msg: content,
	}, function(ret, err){
	
	});
}

function aiba_confirm(title,content)
{
	var dialogBox = api.require('dialogBox');
	dialogBox.alert({
	    texts: {
	        title: title,
	        content: content,
	        leftBtnTitle: '取消',
	        rightBtnTitle: '继续'
	    },
	    styles: {
	        bg: '#fff',
	        w: 300,
	        title: {
	            marginT: 20,
	            iconSize: 40,
	            titleSize: 14,
	            titleColor: '#000'
	        },
	        content: {
	            color: '#000',
	            size: 14
	        },
	        left: {
	            marginB: 0,
	            marginL: 0,
	            w: 150,
	            h: 35,
	            corner: 0,
	            bg: '#FFF',
	            color:"#50D2C2",
	            size: 12
	        },
	        right: {
	            marginB: 0,
	            marginL: 0,
	            w: 150,
	            h: 35,
	            corner: 2,
	            bg: '#50D2C2',
	            color:'#fff',
	            size: 12
	        }
	    }
	}, function(ret) {
	    if (ret.eventType == 'left') 
	    {
	        var dialogBox = api.require('dialogBox');
	        dialogBox.close({
	            dialogName: 'alert'
	        });
	    }
	    else
	    {
	    	aiba_confirm_callback();
	    }
	});
}

function select_city()
{
	//选择地区
	var citySelector = api.require('citySelector');
	citySelector.open({
	    y: api.winHeight/1.6,
	    fixedOn: api.frameName
	}, function(ret, err) {
	    return ret;
	});
}

function select_sex()
{
	//选择性别
	api.actionSheet({
	    title: '请选择性别',
	    cancelTitle: '取消',
	    buttons: ['男', '女'],
	    style:{
		    itemNormalColor:'#fff',
		    fontNormalColor:'#50D2C2',
		    fontPressColor:'#333',
		    titleFontColor:'#333'
	    }
	}, function(ret, err) {
	    var index = ret.buttonIndex;
	    api.sendEvent({
		    name: 'select_sex_back',
		    extra: {
		        sex: index
		    }
		});
	});
}

function select_age()
{
	//选择年龄范围
	var UIActionSelector = api.require('UIActionSelector');
	UIActionSelector.open({
	    datas: 'widget://res/age.json',
	    layout: {
	        row: 5,
	        col: 2,
	        height: 30,
	        size: 16,
	        sizeActive: 18,
	        rowSpacing: 5,
	        colSpacing: 10,
	        maskBg: 'rgba(0,0,0,0.2)',
	        bg: '#fff',
	        color: '#888',
	        colorActive: '#f00',
	        colorSelected: '#f00'
	    },
	    animation: true,
	    cancel: {
	        text: '取消',
	        size: 12,
	        w: 90,
	        h: 35,
	        bg: '#fff',
	        bgActive: '#ccc',
	        color: '#888',
	        colorActive: '#fff'
	    },
	    ok: {
	        text: '确定',
	        size: 12,
	        w: 90,
	        h: 35,
	        bg: '#fff',
	        bgActive: '#ccc',
	        color: '#888',
	        colorActive: '#fff'
	    },
	    title: {
	        text: '请选择',
	        size: 12,
	        h: 44,
	        bg: '#eee',
	        color: '#888'
	    }
	}, function(ret, err) {
		alert(JSON.stringify(ret));
	    api.sendEvent({
		    name: 'select_sex_back',
		    extra: {
		        age:ret
		    }
		});
	});
}

function select_job()
{
	//选择职业
	var UIActionSelector = api.require('UIActionSelector');
	UIActionSelector.open({
	    datas: 'widget://res/job.json',
	    layout: {
	        row: 5,
	        col: 1,
	        height: 30,
	        size: 12,
	        sizeActive: 14,
	        rowSpacing: 5,
	        colSpacing: 10,
	        maskBg: 'rgba(0,0,0,0.2)',
	        bg: '#fff',
	        color: '#888',
	        colorActive: '#f00',
	        colorSelected: '#f00'
	    },
	    animation: true,
	    cancel: {
	        text: '取消',
	        size: 12,
	        w: 90,
	        h: 35,
	        bg: '#fff',
	        bgActive: '#ccc',
	        color: '#888',
	        colorActive: '#fff'
	    },
	    ok: {
	        text: '确定',
	        size: 12,
	        w: 90,
	        h: 35,
	        bg: '#fff',
	        bgActive: '#ccc',
	        color: '#888',
	        colorActive: '#fff'
	    },
	    title: {
	        text: '请选择',
	        size: 12,
	        h: 44,
	        bg: '#eee',
	        color: '#888'
	    },
	    fixedOn: api.frameName
	}, function(ret, err) {
	    
	});
}

function login()
{
	var username = $api.getStorage("user_phone");
	var password = $api.getStorage("user_password");
	var api_url = $api.getStorage("api_url");
	$.ajax({
		url:api_url+'lovebar/login/login',
		type:"POST",
		dataType:"json",
		data:{phoneNum:username,password:password},
		success:function(data){
			var result = data.result;
			if(result == 'success')
			{
				var user_id = data.userId;//id
				var username = data.username;//用户名
				var user_img = data.userPicUrl || "../../image/user.png";//头像
				var user_total_coins = data.totalCoins || 0;//虚拟币
				var user_secretkey = data.secretKey;//SK
				var user_sign = data.sign || "好懒，还没有签名";//签名
				var user_sex = data.sex || '未知';//性别
				var user_birthday = data.birthday || '未知';//生日
				var user_job = data.job || '未知';//职业
				var user_location = data.location || '未知';//位置
				var user_word = data.word || '未知';//恋爱宣言
				
				$api.setStorage("user_id",user_id);
				$api.setStorage("username",username);
				$api.setStorage("user_img",user_img);
				$api.setStorage("user_total_coins",user_total_coins);
				$api.setStorage("user_secretkey",user_secretkey);
				$api.setStorage("user_sign",user_sign);
				$api.setStorage("user_sex",user_sex);
				$api.setStorage("user_birthday",user_birthday);
				$api.setStorage("user_job",user_job);
				$api.setStorage("user_location",user_location);
				$api.setStorage("user_word",user_word);
				$api.setStorage("user_password",password);
				$api.setStorage("user_type","login");
			}
			else
			{
				api.alert({
					title:'错误信息',
					msg:data.message
                });
                //转到登录页面
				api.openWin({
				    name: 'backlogin',
				    url: 'widget://html/login/index.html',
				    hScrollBarEnabled:false
			    });
			}
		},
		error:function(){
			api.toast({
			    msg:'网络不太给力',
			    duration:800,
			    location:'bottom'
		    });
		}
	});
}